import copy
import math


def debug(message: str):
    ...
    # print(message)


t = int(input())
tests = [map(int, input().split()) for _ in range(t)]

def gd(n: int) -> int:
    """Greatest divisor"""
    return next(div for div in range(int(math.sqrt(n)), 0, -1) if n % div == 0)

for a, b, k, m in tests:
    # If we need not even number of squares, it's automatically impossible
    if m % 2:
        debug(f"{m = } is not even, can't split. Abort")
        print(-1)
        continue

    _gd = gd(m)
    cuts = (_gd - 1, m // (_gd) - 1)
    horizontal, vertical = min(cuts), max(cuts)

    debug(f"Initial cuts: {horizontal = }, {vertical = }")

    # Now we need to check if we actually CAN split the field in this way
    # Check for both vertical and horizontal splits
    if horizontal + 1 > a:
        debug("Horizontal cuts exceed the boundaries, attempting fix")
        vertical += horizontal - a + 1
        horizontal = a - 1
        debug(f"{horizontal = }, {vertical = }")
    
    if vertical + 1 > b:
        debug("Vertical cuts exceed the boundaries, attempting fix")
        horizontal += vertical - b + 1
        vertical = b - 1
    
    # If the second if changed our `horizontal` in the way, that it's impossible,
    # the whole split is impossible
    if horizontal + 1 > a:
        debug("Fix failed, cuts exceed boundaries anyway. Abort")
        print(-1)
        continue

    # If we got it right, then just spit it out and continue with next test
    if (horizontal + 1) * (vertical + 1) == m:
        print(horizontal, vertical)
        continue

    debug("Unable to found answer simply, trying brute-force")

    # Otherwise... Deep breath.....
    horizontal_backup, vertical_backup = copy.copy(horizontal), copy.copy(vertical)

    # Let's first try to increase vertical cuts and decrease horizontal, as said in task
    flag = False
    while vertical + 1 < b and (horizontal + 1) * (vertical + 1) < m:
        vertical += 1
        # If we got it right - fine, just print it
        if (horizontal + 1) * (vertical + 1) == m:
            print(horizontal, vertical)
            flag = True
            break

    if flag:
        continue

    debug("Vertical manipulations failed, trying with horizontal")

    # Thew, we weren't able to manipulate verticals, now let's try vice-verca
    vertical, horizontal = copy.copy(vertical_backup), copy.copy(horizontal_backup)

    flag = False
    while horizontal + 1 < a and (horizontal + 1) * (vertical + 1) < m:
        horizontal += 1
        # If we got it right - fine, just print it
        if (horizontal + 1) * (vertical + 1) == m:
            print(horizontal, vertical)
            flag = True
            break

    if flag:
        continue

    vertical = b - 1
    horizontal = 1
    while (horizontal + 1) * (vertical + 1) < m:
        horizontal += 1
    
    if (horizontal + 1) * (vertical + 1) == m:
        print(horizontal, vertical)
        flag = True
        break

    debug("Everything failed. Abort")

    # Well, we tried our best...
    print(-1)
