import typing


t = int(input())

class Solution:
    def __init__(self):
        self._prep_fib()

    def solve(self, n: int) -> int:
        self._overall_cases: set[int] = set()
        self._lfib: list[int] = []
        self._n: int = n
        self._find_lfib()
        self._find_paths()
        return len(self._overall_cases)
    
    def _prep_fib(self):
        self._fib: list[int] = [1, 1] + [0] * 10 ** 3
        current_index: int = 1
        while self._fib[current_index] ** 2 < 10 ** 18:
            self._fib[current_index + 1] = self._fib[current_index] + self._fib[current_index - 1]
            current_index += 1

        self._fib.pop(0)
        self._fib.pop(0)
        if not self._fib[-1]:
            self._fib = self._fib[:self._fib.index(0)]
    
    def _find_lfib(self):
        self._lfib = [0]
        i: int = 0
        while self._lfib[-1] <= n:
            self._lfib += [self._fib[i]]
            i += 1
        
        self._lfib.pop(0)
        if self._lfib[-1] > n:
            self._lfib.pop()

    def _find_paths(
        self,
        current_res: int = 1,
        current_path: typing.Optional[list[int]] = None,
    ) -> int:
        if current_path is None:
            current_path = []

        for multiplier in self._lfib:
            if multiplier * current_res == self._n:
                current_path += [multiplier]

                current_path_hashable = tuple(sorted(current_path))
                if current_path_hashable not in self._overall_cases:
                    self._overall_cases.add(current_path_hashable)

                continue

            if multiplier * current_res > self._n:
                continue
        
            self._find_paths(current_res * multiplier, current_path + [multiplier])
        
    

solution = Solution()

for _ in range(t):
    n = int(input())
    print(solution.solve(n))
