k, n = map(int, input().split())

# TODO: Dynamic field size
SIZE = 10 ** 3
OFFSET = SIZE // 2


class Solution:
    def __init__(self):
        self._map = [[0 for _ in range(SIZE)] for _ in range(SIZE)]
        self._current_pos = (OFFSET, OFFSET)
    
    def _sum(self) -> int:
        overall_sum = 0
        for line in self._map:
            overall_sum += sum(line)
        
        return overall_sum

    def _print(self):
        print(" ", " ".join(map(str, range(len(self._map[0])))))
        for j, line in enumerate(self._map):
            print(j, " ".join(map(lambda x: "#" if x else " ", line)))
        
        print('=' * 10)
    
    def feed(self, k: int, directions: list[tuple[str, int]]) -> int:
        for direction, distance in directions:
            if direction == "N":
                new_pos = (self._current_pos[0], self._current_pos[1] - distance)
            elif direction == "S":
                new_pos = (self._current_pos[0], self._current_pos[1] + distance)
            elif direction == "W":
                new_pos = (self._current_pos[0] - distance, self._current_pos[1])
            elif direction == "E":
                new_pos = (self._current_pos[0] + distance, self._current_pos[1])

            x = (self._current_pos[0], new_pos[0])
            y = (self._current_pos[1], new_pos[1])

            self._current_pos = new_pos

            for row in range(min(y) - k + 1, max(y) + 1):
                for col in range(min(x), max(x) + k):
                    self._map[row][col] = 1

        return self._sum() 


solution = Solution()

directions = [(lambda x: (x[0], int(x.split()[1])))(input()) for _ in range(n)]

print(solution.feed(k, directions))
