G = int(input())
n = int(input())
strings = [input() for _ in range(n)]


def get_possible_neighboors(strings: list, string: str) -> list:
    return [str_ for str_ in strings if str_[0] == string[1]]


def markov_s(current_s: str, markov: dict, length: int):
    if len(current_s) >= length:
        return [current_s]


    s = set()
    for string in markov[current_s[-2:]]:
        for seq in markov_s(current_s + string[1:], markov, length):
            s.add(seq)
    
    return s


def get_markov_sequences(markov: dict, length: int) -> list:
    sequences = set()
    for start in markov:
        for seq in markov_s(start, markov, length):
            sequences.add(seq)

    return sequences


for string in strings:
    syllable_groups = {}
    markov = {}
    groups = [string[i:i+2] for i in range(len(string) - 1)]

    for group in groups:
        syllable_groups.setdefault(group, 0)
        syllable_groups[group] += 1
        if group not in markov:
            markov[group] = get_possible_neighboors(groups, group)

    possible_eq = get_markov_sequences(markov, len(string))
    c = 0
    for possible in possible_eq:
        _syll = {}

        groups = [possible[i:i+2] for i in range(len(possible) - 1)]

        _syllable_groups = {}

        for group in groups:
            _syllable_groups.setdefault(group, 0)
            _syllable_groups[group] += 1
        
        if all(syllable_groups.get(key) == _syllable_groups.get(key) for key in set(list(syllable_groups) + list(_syllable_groups))):
            # print(possible)
            c += 1
        
    print(c)

